"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CigarUnit(ProtocolElement):
    """
    A structure for an instance of a CIGAR operation.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "operation",
        "operationLength",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import ga4gh as ga4gh_3_1_1

        return {
            "operation": ga4gh_3_1_1.CigarOperation,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import ga4gh as ga4gh_3_1_1

        return {
            "org.ga4gh.models.CigarOperation": ga4gh_3_1_1.CigarOperation,
            "org.ga4gh.models.CigarUnit": ga4gh_3_1_1.CigarUnit,
        }

    __slots__ = [
        "operation",
        "operationLength",
        "referenceSequence",
    ]

    def __init__(
        self,
        operation,
        operationLength,
        referenceSequence=None,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_1_1.CigarUnit model.

        :param operation:
            The operation type.
        :type operation: CigarOperation
        :param operationLength:
            The number of bases that the operation runs for.
        :type operationLength: int
        :param referenceSequence:
            `referenceSequence` is only used at mismatches (`SEQUENCE_MISMATCH`)
            and deletions (`DELETE`). Filling this field replaces the
            MD tag.   If the relevant information is not available,
            leave this field as `null`.
        :type referenceSequence: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.1.1"
